// FUNCTIONS - helpers

// This prepares the specific files to be installed.
function setupFiles(su) {
   var err = 0;

   if (su == null) {
      dbgMsg("Error passing su to setupFiles: " + err);
      return -1;
   }

   err = su.StartInstall("/Net2Phone/Plugin/WorkAround",        // Package name
                         vi,
                         netscape.softupdate.SoftwareUpdate.FULL_INSTALL);
   if (err !=0) {
      dbgMsg("Error at startInstall: " + err);
      return err;
   }

   // Get folders.
   WinSystemFolder = su.GetFolder("Win System");
   if (WinSystemFolder == null) {
      dbgMsg("ERROR GETTING System FOLDER: Net2Phone");
      return -1;
   }
   // Get folders.
   TempDirectory = su.GetFolder("Temporary");
   if (TempDirectory == null) {
      dbgMsg("ERROR GETTING Temporary FOLDER: Net2Phone");
      return -1;
   }
   WinFolder = su.GetFolder("Windows");
   if (WinFolder == null) {
      dbgMsg("ERROR GETTING Windows FOLDER: Net2Phone");
      return -1;
   }
   PIFolder = su.GetFolder("Plugins");
   if (PIFolder == null) {
      dbgMsg("ERROR GETTING Plugin FOLDER: Net2Phone");
      return -1;
   }

   // Add subcomponents.
   //   Net2Phone files

   su.Execute("n2pterm.exe");
   newSub("", "N2PUtil.dll",    vi, WinSystemFolder,        "N2PUtil.dll");

   newSub("", "Net2fone.exe", vi, TempDirectory, "Net2fone.exe");
   newSub("", "net2fone.skn",  vi, TempDirectory, "net2fone.skn");
   newSub("", "net2fone.hlp",  vi, TempDirectory, "net2fone.hlp");
   newSub("", "n2pres.dll",   vi, TempDirectory, "n2pres.dll");
   newSub("", "sx7396.dll",   vi, TempDirectory, "sx7396.dll");
   newSub("", "sxvad.dll",   vi, TempDirectory, "sxvad.dll");
   newSub("", "net2fone.txt",   vi, TempDirectory, "net2fone.txt");
   newSub("", "term.n2p",   vi, TempDirectory, "term.n2p");
   newSub("", "hold.n2p",   vi, TempDirectory, "hold.n2p");
   newSub("", "followme.n2p",   vi, TempDirectory, "followme.n2p");
   newSub("", "license.txt",   vi, TempDirectory, "license.txt");
   newSub("", "welcome.n2p",  vi, TempDirectory, "welcome.n2p");
   newSub("", "ringout.n2p",  vi, TempDirectory, "ringout.n2p");
   newSub("", "busy.n2p",  vi, TempDirectory, "busy.n2p");
   newSub("", "N2PUtil.dll",  vi, TempDirectory, "N2PUtil.dll");
   newSub("", "N2PAuto.exe",  vi, TempDirectory, "N2PAuto.exe");
   newSub("", "setupN2P.exe",  vi, TempDirectory, "setupN2P.exe");
   newSub("", "npn2p.dll",    vi, TempDirectory,        "npn2p.dll");
   newSub("", "c2t.lst", vi, TempDirectory, "c2t.lst");
   newSub("", "n2pold.lst", vi, TempDirectory, "n2pold.lst");
   newSub("", "N2PInst.lst", vi, TempDirectory, "N2PInst.lst");
   newSub("", "n2p.lst", vi, TempDirectory, "n2p.lst");
   newSub("", "n2pfax.lst", vi, TempDirectory, "n2pfax.lst");
   newSub("", "n2p.ico", vi, TempDirectory, "n2p.ico");

   newSub("", "n2pterm.exe",    vi, PIFolder,        "n2pterm.exe");
   newSub("", "N2PUtil.dll",    vi, PIFolder,        "N2PUtil.dll");
   newSub("", "npn2pins.dll",    vi, PIFolder,        "npn2pins.dll");

   newSub("", "N2PUtil.dll",  vi, TempDirectory, "N2PUtil.dll");
   newSub("", "N2PAuto.exe",  vi, TempDirectory, "N2PAuto.exe");
   newSub("", "setupN2P.exe",  vi, TempDirectory, "setupN2P.exe");
   newSub("", "npn2p.dll",    vi, TempDirectory,        "npn2p.dll");
   newSub("", "N2PInst.lst", vi, TempDirectory, "N2PInst.lst");
   newSub("", "n2pfax.lst", vi, TempDirectory, "n2pfax.lst");

   newSub("", "tiff32.dll",  vi, TempDirectory, "tiff32.dll");
   newSub("", "tiff.dll",  vi, TempDirectory, "tiff.dll");
   newSub("", "blicefax.drv",  vi, TempDirectory, "blicefax.drv");
   newSub("", "blicent.dll",  vi, TempDirectory, "blicent.dll");
   newSub("", "bi_res.dll",  vi, TempDirectory, "bi_res.dll");
   newSub("", "bliceuif.dll",  vi, TempDirectory, "bliceuif.dll");
   newSub("", "blproces.dll",  vi, TempDirectory, "blproces.dll");
   newSub("", "blicent.ini",  vi, TempDirectory, "blicent.ini");
   newSub("", "addracc.dll",  vi, TempDirectory, "addracc.dll");
   newSub("", "ICQMAPI.dll",  vi, TempDirectory, "ICQMAPI.dll");
   newSub("", "RasN2P.dll",  vi, TempDirectory, "RasN2P.dll");
   newSub("", "N2pFax.dll",  vi, TempDirectory, "N2pFax.dll");
   newSub("", "n2pfax.exe",  vi, TempDirectory, "n2pfax.exe");

   su.Execute("regn2p.exe");

   // If any subcomponent failed, the installation aborts here.
   if (newSubFailure) {
      dbgMsg("Error adding at least one subcomponent.");
      abortMe();
    }

   return 0;
}

// Used only for debugging when execution needs to be
// slowed down to follow the output to the Java Console.
function delay(amount) {
   if( (debugOutput) && (amount > 0) )
   {   
      var time = new Date();
      var seconds = time.getSeconds();
      var startCount = 80;
      var newSeconds = 70;

      startCount = (seconds + amount ) % 60;
      time = new Date();
      newSeconds = time.getSeconds();
      while (newSeconds != startCount ) {
         time = new Date();
         newSeconds = time.getSeconds();
      }
   }
}

// Conditionally displays a message only when debugging.
function dbgIfMsg(condition, message) {
   if(debugOutput && condition)
      java.lang.System.out.println(message);
}


// Displays a message only when debugging.
function dbgMsg(message) {
   if(debugOutput)
      java.lang.System.out.println(message);
}

// Pops an alert window only when NOT installing in silent mode.
function cAlert(message) {
   if(!this.silent)
      alert(message);
}


// Checks OS and version information.
function checkSystemEnvironment() {
   var err = 0;

   if(debugOutput) {
      registry_vi = netscape.softupdate.Trigger.GetVersionInfo("/Net2Phone/Plugin/WorkAround");
      dbgIfMsg( (registry_vi == null ), "Warning: No registry info for Net2Phone node");
      if (registry_vi != null) {
         dbgIfMsg( (vi.compareTo(registry_vi) <= 0), 
                    "Warning: Version is no newer than previously installed version.");
      }
   }

   dbgMsg("The value of navigator.platform is: " + navigator.platform);           
   if (navigator.platform != "Win32") {
      err = -20; // wrong OS 
      dbgMsg("Error: Wrong operating system!");
      cAlert("Error: Wrong operating system: " + navigator.platform);
      return err;
   }
   return err;
}

// A wrapper for calling the AddSubcomponent() function.
function newSub(fName, jarFilePath, tgtVI, tgtFolder, tgtFilePath) {
   dbgMsg("Filename in newSub is: " + jarFilePath);
   var err = su.AddSubcomponent(fName,tgtVI,jarFilePath,tgtFolder,tgtFilePath,this.force);
   dbgIfMsg( (err != 0), "Error Adding SubComponent " + fName + "error value: " + err);
   if(err != 0) {
      newSubFailure = true;
      alert("Error Adding SubComponent " + fName);
   }
   delay(FileDelayTime);
}

// Handles catastrophic errors.
function abortMe(err) {
   if(!abortCalled) {
      dbgMsg("Install Aborted." + err);
      cAlert("Install Aborted." + err);
      su.AbortInstall();
      abortCalled = true;
   }
}

// End of functions.

/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////

// ===================== START ACTUAL INSTALLATION =========================
// 
// Global variable declarations
// 
var updateObjectName = "Net2Phone Install";
var versionMaj = 10;
var versionMin = 1;
var versionRel = 0;
var versionBld = 0;
var FileDelayTime = 0; // Number of seconds delay between subcomponents when debugging

var abortCalled   = false;
var newSubFailure = false;
var debugOutput   = true;  // Turns debugging output on/off

var vi = new netscape.softupdate.VersionInfo(versionMaj, versionMin, versionRel, versionBld);
    dbgIfMsg( (vi == null), "Warning: Unable to create the VersionInfo object.");
var su = new netscape.softupdate.SoftwareUpdate( this, updateObjectName );
    dbgIfMsg( (su == null), "Warning: Unable to create the SoftwareUpdate object.");

//-------------------------------------------------
// Here starts the main body of execution.
//-------------------------------------------------
java.lang.System.out.println("Starting script...");

var err = 0;
if ( (su != null) ) {
   dbgMsg("new SoftwareUpdate succeeded.");
   err = checkSystemEnvironment();
   if ( err == 0 ) {
      dbgMsg("checkSystemEnvirnoment succeeded.");
      err = setupFiles(su);
      if (err == 0) {
         dbgMsg("setupFiles succeeded.");
         err = su.FinalizeInstall();

	navigator.plugins.refresh(true);

         if (err == 0) {
            //cAlert("Install Successfully Completed");
         }
         else {
            dbgMsg("Error at FinalizeInstall: " + err);
           //abortMe(err);
         } //FinalizeInstall
      }
      else {
         dbgMsg("Error at setupFiles: " + err);
         abortMe(err);
      } //setupFiles
   } 
   else {
      dbgMsg("Error at checkSystemEnvironment: " + err);
      abortMe(err);
   } //checkSystemEnvironment

	
	navigator.plugins.refresh(true);
}
